import { createTraitFactory, } from 'ngrx-traits';
import { createCrudTraitActions } from '../crud/crud.trait.actions';
import { createCrudTraitSelectors } from '../crud/crud.trait.selectors';
import { createCrudInitialState, createCrudTraitReducer, } from '../crud/crud.trait.reducer';
import { crudTraitKey, } from './crud.model';
import { loadEntitiesTraitKey, } from '../load-entities/load-entities.model';
import { createCrudTraitMutators } from './crud.trait.mutators';
export function addCrudEntities({ storeChanges = false, } = {}) {
    return createTraitFactory({
        key: crudTraitKey,
        depends: [loadEntitiesTraitKey],
        config: { storeChanges },
        actions: ({ actionsGroupKey }) => createCrudTraitActions(actionsGroupKey),
        selectors: ({ previousSelectors }) => createCrudTraitSelectors(previousSelectors),
        mutators: ({ allConfigs }) => createCrudTraitMutators(allConfigs),
        initialState: ({ previousInitialState }) => createCrudInitialState(previousInitialState),
        reducer: ({ initialState, allActions, allMutators, allConfigs }) => createCrudTraitReducer(initialState, allActions, allMutators, allConfigs),
    });
}
//# sourceMappingURL=crud.trait.js.map