import { createReducer, on } from '@ngrx/store';
import { insertIf } from 'ngrx-traits';
export function createCrudInitialState(previousInitialState) {
    return Object.assign(Object.assign({}, previousInitialState), { changes: [] });
}
export function createCrudTraitReducer(initialState, allActions, allMutators, allConfigs) {
    var _a, _b, _c;
    const sortRemote = (_a = allConfigs.sort) === null || _a === void 0 ? void 0 : _a.remote;
    const filterRemote = allConfigs.filter && !((_b = allConfigs.filter) === null || _b === void 0 ? void 0 : _b.filterFn);
    const paginationCacheType = (_c = allConfigs.pagination) === null || _c === void 0 ? void 0 : _c.cacheType;
    return createReducer(initialState, on(allActions.add, (state, { entities }) => allMutators.add(entities, state)), on(allActions.update, (state, { updates }) => allMutators.update(updates, state)), on(allActions.upsert, (state, { entities }) => allMutators.upsert(entities, state)), on(allActions.remove, (state, { keys }) => allMutators.remove(keys, state)), on(allActions.removeAll, (state, { predicate }) => predicate
        ? allMutators.remove(predicate, state)
        : allMutators.removeAll(state)), on(allActions.clearChanges, (state) => allMutators.clearChanges(state)), ...insertIf(sortRemote, () => on(allActions.sort, (state) => allMutators.clearChanges(state))), ...insertIf(filterRemote, () => on(allActions.filter, (state) => allMutators.clearChanges(state))), ...insertIf(!allActions.loadPageSuccess, () => on(allActions.fetchSuccess, (state) => allMutators.clearChanges(state))), ...insertIf(!!allActions.loadPageSuccess && paginationCacheType === 'partial', () => on(allActions.loadPageSuccess, (state) => allMutators.clearChanges(state))));
}
//# sourceMappingURL=crud.trait.reducer.js.map