import { paginationTraitKey, } from '../pagination/pagination.model';
import { createFilterTraitEffects } from './filter.trait.effect';
import { createFilterInitialState, createFilterTraitReducer, } from './filter.trait.reducer';
import { filterTraitKey, } from './filter.model';
import { createFilterTraitSelectors } from './filter.trait.selectors';
import { loadEntitiesTraitKey, } from '../load-entities/load-entities.model';
import { createFilterTraitMutators } from './filter.trait.mutators';
import { createTraitFactory } from 'ngrx-traits';
import { createFilterTraitActions } from './filter.trait.actions';
export function addFilter({ defaultDebounceTime = 400, defaultFilter, filterFn, } = {}) {
    return createTraitFactory({
        key: filterTraitKey,
        depends: [paginationTraitKey, loadEntitiesTraitKey],
        config: { defaultDebounceTime, defaultFilter, filterFn },
        actions: ({ actionsGroupKey }) => createFilterTraitActions(actionsGroupKey),
        selectors: () => createFilterTraitSelectors(),
        mutators: () => createFilterTraitMutators(),
        initialState: ({ previousInitialState, allConfigs, }) => createFilterInitialState(previousInitialState, allConfigs),
        reducer: ({ initialState, allActions, allMutators }) => createFilterTraitReducer(initialState, allActions, allMutators),
        effects: ({ allActions, allSelectors, allConfigs }) => createFilterTraitEffects(allActions, allSelectors, allConfigs),
    });
}
//# sourceMappingURL=filter.trait.js.map