import { createLoadEntitiesInitialState, createLoadEntitiesTraitReducer, } from './load-entities.trait.reducer';
import { loadEntitiesTraitKey, } from './load-entities.model';
import { createLoadEntitiesTraitMutators } from './load-entities.mutators';
import { createTraitFactory } from 'ngrx-traits';
import { createEntityAdapter } from '@ngrx/entity';
import { createLoadEntitiesTraitActions } from './load-entities.trait.actions';
import { createLoadEntitiesTraitSelectors } from './load-entities.trait.selectors';
export function addLoadEntities(traitConfig) {
    const adapter = createEntityAdapter(traitConfig);
    return createTraitFactory({
        key: loadEntitiesTraitKey,
        config: Object.assign(Object.assign({}, traitConfig), { adapter }),
        actions: ({ actionsGroupKey }) => createLoadEntitiesTraitActions(actionsGroupKey),
        selectors: ({ allConfigs }) => createLoadEntitiesTraitSelectors(allConfigs),
        mutators: ({ allConfigs }) => createLoadEntitiesTraitMutators(allConfigs),
        initialState: ({ previousInitialState, allConfigs, }) => createLoadEntitiesInitialState(previousInitialState, allConfigs),
        reducer: ({ initialState, allActions, allMutators, allConfigs }) => createLoadEntitiesTraitReducer(initialState, allActions, allMutators, allConfigs),
    });
}
//# sourceMappingURL=load-entities.trait.js.map