import { createReducer, on } from '@ngrx/store';
import { insertIf } from 'ngrx-traits';
export function createLoadEntitiesInitialState(previousInitialState = {}, allConfigs) {
    const traitConfig = allConfigs.loadEntities;
    const adapter = traitConfig.adapter;
    return Object.assign(Object.assign(Object.assign({}, previousInitialState), adapter.getInitialState()), { status: undefined });
}
export function createLoadEntitiesTraitReducer(initialState, actions, allMutators, allConfigs) {
    const handleEntitiesMerge = !(allConfigs === null || allConfigs === void 0 ? void 0 : allConfigs.pagination);
    return createReducer(initialState, on(actions.fetch, (state) => (Object.assign(Object.assign({}, state), { status: 'loading' }))), on(actions.fetchFail, (state) => (Object.assign(Object.assign({}, state), { status: 'fail' }))), on(actions.fetchSuccess, (state) => (Object.assign(Object.assign({}, state), { status: 'success' }))), ...insertIf(handleEntitiesMerge, () => on(actions.fetchSuccess, (state, { entities }) => allMutators.setAll(entities, Object.assign({}, state)))));
}
//# sourceMappingURL=load-entities.trait.reducer.js.map