import { isFail, isLoading, isSuccess } from './load-entities.utils';
import { createSelector } from '@ngrx/store';
import { selectFilter } from '../filter/filter.trait.selectors';
export function createLoadEntitiesTraitSelectors(allConfigs) {
    var _a, _b;
    const adapter = (_a = allConfigs === null || allConfigs === void 0 ? void 0 : allConfigs.loadEntities) === null || _a === void 0 ? void 0 : _a.adapter;
    const entitySelectors = adapter === null || adapter === void 0 ? void 0 : adapter.getSelectors();
    const filterFunction = (_b = allConfigs === null || allConfigs === void 0 ? void 0 : allConfigs.filter) === null || _b === void 0 ? void 0 : _b.filterFn;
    let selectors = entitySelectors;
    if (filterFunction && entitySelectors) {
        const selectAll = createSelector(entitySelectors.selectAll, selectFilter, (entities, filters) => filters ? entities.filter((e) => filterFunction(filters, e)) : entities);
        selectors = {
            selectAll,
            selectEntities: createSelector(entitySelectors.selectEntities, selectFilter, (entities, filters) => {
                const result = {};
                for (const id in entities) {
                    const e = entities[id];
                    if (filterFunction(filters, e)) {
                        result[id] = e;
                    }
                }
                return result;
            }),
            selectTotal: createSelector(selectAll, (entities) => entities.length),
            selectIds: createSelector(selectAll, (entities) => entities.map((e) => adapter === null || adapter === void 0 ? void 0 : adapter.selectId(e))),
        };
    }
    return Object.assign(Object.assign({}, selectors), { isFail,
        isLoading,
        isSuccess });
}
//# sourceMappingURL=load-entities.trait.selectors.js.map