import { createMultiSelectionTraitActions } from './multi-selection.trait.actions';
import { createMultiSelectionTraitSelectors } from './multi-selection.trait.selectors';
import { loadEntitiesTraitKey, } from '../load-entities/load-entities.model';
import { createTraitFactory } from 'ngrx-traits';
import { createMultiSelectionInitialState, createMultiSelectionTraitReducer, } from './multi-selection.trait.reducer';
import { createMultiSelectionTraitMutators } from './multi-selection.trait.mutators';
export function addMultiSelection() {
    return createTraitFactory({
        key: 'multiSelection',
        depends: [loadEntitiesTraitKey],
        actions: ({ actionsGroupKey }) => createMultiSelectionTraitActions(actionsGroupKey),
        selectors: ({ previousSelectors }) => createMultiSelectionTraitSelectors(previousSelectors),
        initialState: ({ previousInitialState }) => createMultiSelectionInitialState(previousInitialState),
        mutators: ({ allSelectors }) => createMultiSelectionTraitMutators(allSelectors),
        reducer: ({ initialState, allActions, allMutators, allConfigs }) => createMultiSelectionTraitReducer(initialState, allActions, allMutators, allConfigs),
    });
}
//# sourceMappingURL=multi-selection.trait.js.map