import { toMap } from 'ngrx-traits';
import { multiClearSelection, multiDeselect, multiSelect, multiToggleSelect, } from './multi-selection.utils';
export function createMultiSelectionTraitMutators({ isAllSelected, }) {
    function toggleSelectAll(state) {
        const allSelected = isAllSelected(state);
        if (allSelected === 'all') {
            return Object.assign(Object.assign({}, state), { selectedIds: {} });
        }
        else {
            return Object.assign(Object.assign({}, state), { selectedIds: toMap(state.ids) });
        }
    }
    return {
        multiDeselect,
        multiSelect,
        multiToggleSelect,
        toggleSelectAll,
        multiClearSelection,
    };
}
//# sourceMappingURL=multi-selection.trait.mutators.js.map