import { createSelector } from '@ngrx/store';
import { selectTotalSelected } from './multi-selection.utils';
export function createMultiSelectionTraitSelectors(previousSelectors) {
    const { selectEntities, selectTotal } = previousSelectors;
    function selectIdsSelected(state) {
        return state.selectedIds;
    }
    const selectAllIdsSelected = createSelector(selectIdsSelected, (ids) => Object.keys(ids));
    const selectEntitiesSelected = createSelector(selectAllIdsSelected, selectEntities, (selectedIds, entities) => selectedIds.reduce((acum, id) => {
        acum[id] = entities[id];
        return acum;
    }, {}));
    const selectAllSelected = createSelector(selectAllIdsSelected, selectEntities, (selectedIds, entities) => selectedIds.map((id) => entities[id]));
    const isAllSelected = createSelector((state) => selectTotal(state), selectTotalSelected, (total, totalSelected) => totalSelected === total ? 'all' : totalSelected === 0 ? 'none' : 'some');
    return {
        selectIdsSelected,
        selectAllIdsSelected,
        selectEntitiesSelected,
        selectAllSelected,
        selectTotalSelected,
        isAllSelected,
    };
}
//# sourceMappingURL=multi-selection.trait.selectors.js.map