import { createAction, props } from '@ngrx/store';
export function createPaginationTraitActions(actionsGroupKey) {
    const actions = {
        loadPage: createAction(`${actionsGroupKey} load page`, ({ index, forceLoad }) => ({
            index,
            forceLoad,
        })),
        loadPageSuccess: createAction(`${actionsGroupKey} load
          page success`),
        loadPageFail: createAction(`${actionsGroupKey} load page fail`),
        loadPreviousPage: createAction(`${actionsGroupKey} load previous page`),
        loadNextPage: createAction(`${actionsGroupKey} load next page`),
        loadFirstPage: createAction(`${actionsGroupKey} load first page`, (forceLoad) => ({ forceLoad })),
        loadLastPage: createAction(`${actionsGroupKey} load last page`),
        clearPagesCache: createAction(`${actionsGroupKey} clear cache`),
        setRequestPage: createAction(`${actionsGroupKey} set request page`, props()),
    };
    return actions;
}
//# sourceMappingURL=pagination.trait.actions.js.map