import { paginationTraitKey, } from './pagination.model';
import { createPaginationTraitSelectors } from './pagination.trait.selectors';
import { createPaginationTraitActions } from './pagination.trait.actions';
import { loadEntitiesTraitKey, } from '../load-entities/load-entities.model';
import { createPaginationInitialState, createPaginationTraitReducer, } from './pagination.trait.reducer';
import { createPaginationTraitEffects } from './pagination.trait.effects';
import { createTraitFactory } from 'ngrx-traits';
import { createPaginationTraitMutators } from './pagination.trait.mutators';
export function addPagination({ cacheType = 'full', pageSize = 20, currentPage = 0, pagesToCache = 3, } = {}) {
    return createTraitFactory({
        key: paginationTraitKey,
        depends: [loadEntitiesTraitKey],
        config: {
            cacheType,
            pageSize,
            currentPage,
            pagesToCache,
        },
        actions: ({ actionsGroupKey }) => createPaginationTraitActions(actionsGroupKey),
        selectors: ({ previousSelectors, allConfigs, }) => createPaginationTraitSelectors(previousSelectors, allConfigs),
        mutators: ({ allSelectors, allConfigs }) => createPaginationTraitMutators(allSelectors, allConfigs),
        initialState: ({ previousInitialState, allConfigs, }) => createPaginationInitialState(previousInitialState, allConfigs),
        reducer: ({ initialState, allActions, allSelectors, allMutators, allConfigs, }) => createPaginationTraitReducer(initialState, allActions, allSelectors, allMutators, allConfigs),
        effects: ({ allActions, allSelectors }) => createPaginationTraitEffects(allActions, allSelectors),
    });
}
//# sourceMappingURL=pagination.trait.js.map