import { createTraitFactory } from 'ngrx-traits';
import { createAction, createReducer, on, Store } from '@ngrx/store';
import { Injectable } from '@angular/core';
import { TraitEffect } from 'ngrx-traits';
import { Actions, createEffect, ofType } from '@ngrx/effects';
import { mapTo } from 'rxjs/operators';
import * as i0 from "@angular/core";
import * as i1 from "@ngrx/effects";
import * as i2 from "@ngrx/store";
export function addReset(traitConfig = {}) {
    return createTraitFactory({
        key: 'reset',
        config: traitConfig,
        actions: ({ actionsGroupKey }) => ({
            reset: createAction(`${actionsGroupKey} Reset State`),
        }),
        reducer: ({ allActions, initialState }) => createReducer(initialState, on(allActions.reset, () => initialState)),
        effects: ({ allActions }) => {
            var _a;
            class ResetEffect extends TraitEffect {
                //TODO: not sure why Im forced to override this constructor
                // or test wont pass, strangely doesnt happen in other files
                // with similar case like pagination.effects.ts
                constructor(actions$, store) {
                    var _a;
                    super(actions$, store);
                    this.externalReset$ = ((_a = traitConfig === null || traitConfig === void 0 ? void 0 : traitConfig.resetOn) === null || _a === void 0 ? void 0 : _a.length) &&
                        createEffect(() => {
                            return this.actions$.pipe(ofType(...traitConfig === null || traitConfig === void 0 ? void 0 : traitConfig.resetOn), mapTo(allActions.reset()));
                        });
                }
            }
            ResetEffect.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: ResetEffect, deps: [{ token: i1.Actions }, { token: i2.Store }], target: i0.ɵɵFactoryTarget.Injectable });
            ResetEffect.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: ResetEffect });
            i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.1.2", ngImport: i0, type: ResetEffect, decorators: [{
                        type: Injectable
                    }], ctorParameters: function () { return [{ type: i1.Actions }, { type: i2.Store }]; } });
            return ((_a = traitConfig === null || traitConfig === void 0 ? void 0 : traitConfig.resetOn) === null || _a === void 0 ? void 0 : _a.length) ? [ResetEffect] : [];
        },
    });
}
//# sourceMappingURL=reset.trait.js.map