import { createTraitFactory, } from 'ngrx-traits';
import { createSingleSelectionTraitActions } from './single-selection.trait.actions';
import { createSingleSelectionTraitSelectors } from './single-selection.trait.selectors';
import { createSingleSelectionInitialState, createSingleSelectionTraitReducer, } from './single-selection.trait.reducer';
import { createSingleSelectionTraitMutators } from './single-selection.trait.mutators';
import { loadEntitiesTraitKey, } from '../load-entities/load-entities.model';
export function addSingleSelection(config) {
    return createTraitFactory({
        key: 'singleSelection',
        depends: [loadEntitiesTraitKey],
        config,
        actions: ({ actionsGroupKey }) => createSingleSelectionTraitActions(actionsGroupKey),
        selectors: () => createSingleSelectionTraitSelectors(),
        mutators: () => createSingleSelectionTraitMutators(),
        initialState: ({ previousInitialState, allConfigs, }) => createSingleSelectionInitialState(previousInitialState, allConfigs),
        reducer: ({ initialState, allActions, allMutators, allConfigs }) => createSingleSelectionTraitReducer(initialState, allActions, allMutators, allConfigs),
    });
}
//# sourceMappingURL=single-selection.trait.js.map