import { createSortTraitMutators } from './sort.trait.mutators';
import { createSortInitialState, createSortTraitReducer, } from './sort.trait.reducer';
import { createSortTraitSelectors } from './sort.trait.selectors';
import { createSortTraitEffect } from './sort.trait.effect';
import { sortTraitKey, } from './sort.model';
import { loadEntitiesTraitKey, } from '../load-entities/load-entities.model';
import { createTraitFactory } from 'ngrx-traits';
import { createSortTraitActions } from './sort.trait.actions';
export function addSort({ remote = false, defaultSort, } = {}) {
    return createTraitFactory({
        key: sortTraitKey,
        depends: [loadEntitiesTraitKey],
        config: { remote, defaultSort },
        actions: ({ actionsGroupKey }) => createSortTraitActions(actionsGroupKey),
        selectors: () => createSortTraitSelectors(),
        mutators: ({ allSelectors, allConfigs }) => createSortTraitMutators(allSelectors, allConfigs),
        initialState: ({ previousInitialState, allConfigs, }) => createSortInitialState(previousInitialState, allConfigs),
        reducer: ({ initialState, allActions, allMutators, allConfigs }) => createSortTraitReducer(initialState, allActions, allMutators, allConfigs),
        effects: ({ allActions, allConfigs }) => createSortTraitEffect(allActions, allConfigs),
    });
}
//# sourceMappingURL=sort.trait.js.map